
;;  SCHEME IN SCHEME
;;  Copyright (C) 2008  Vilem Vychodil, <vilem.vychodil@upol.cz>
;;
;;  This program is free software; you can redistribute it and/or modify
;;  it under the terms of the GNU General Public License as published by
;;  the Free Software Foundation; version 2 of the License.
;;
;;  This program is distributed in the hope that it will be useful,
;;  but WITHOUT ANY WARRANTY; without even the implied warranty of
;;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
;;  GNU General Public License for more details.
;;
;;  You should have received a copy of the GNU General Public License
;;  along with this program; if not, write to the Free Software
;;  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

;; define, ktery nejprve ,,zhmnotni sebe sama'' a pouzije ,,sebe sama''
;; k zavedeni ,,sebe sama'' do prostredi
((lambda (define-proc)
   (define-proc
     (environment->list (environment-parent (the-environment)))
     'define
     (lambda (env symbol value)
       (define-proc (environment->list env) symbol value))))
 (lambda (table symbol value)
   ((lambda (y)
      (y y (cdr table) symbol value))
    (lambda (modify aux symbol value)
      (if (null? aux)
	  (set-cdr! table (cons (cons symbol value) (cdr table)))
	  (if (equal? (car (car aux)) symbol)
	      (set-cdr! (car aux) value)
	      (modify modify (cdr aux) symbol value)))))))

(define (the-environment) 'blah 10)

blah

(define (the-environment)
  'faktorial
  (lambda (n)
    (if (= n 0)
	1
	(* n (faktorial (- n 1))))))

(define (the-environment)
  'map
  (lambda (f l)
    (if (null? l)
	'()
	(cons (f (car l))
	      (map f (cdr l))))))

(map faktorial '(0 1 2 3 4 5 6 7 8 9 10))

pi

(define (the-environment) 'pi 3.14)

pi

(eval 'pi (environment-parent (the-environment)))

(procedure-body map)
(procedure-body define)
(eval '(procedure-body define-proc)
      (procedure-environment define))

;; pote co jsme zavedli lookup-env, muzeme pouzit

(lookup-env (the-environment) '+)

; tohle redefinuje + na hodnotu 10
; (set-cdr! (lookup-env (the-environment) '+) 10)

;; nyni muzeme zlepsit lousy define

((lambda (y)
   (y (environment-parent (the-environment)) 'define y))
 (lambda (env symbol value)
   (if (lookup-env env symbol #f)
       (set-cdr! (lookup-env env symbol) value)
       ((lambda (table)
	  (set-cdr! table (cons (cons symbol value) (cdr table))))
	(environment->list env)))))

;; dale muzeme udelat ``lousy set!''

(define (the-environment)
  'set!
  (lambda (env symbol value)
    (set-cdr! (lookup-env env symbol) value)))

(set! (the-environment) '* 10)
*
(lookup-env (the-environment) '*)

;; BEGIN: mame i begin

(begin)

(begin 1)

(begin 1 2 3)

((lambda ()
   (begin
     (define (the-environment) 'x 10)
     (* x x x))))

(lookup-env (the-environment) 'x)

(begin
  (define (the-environment) 'x 10)
  (* x x x))

(lookup-env (the-environment) 'x)

;; SET!: vnitrni set!

(set! + 100)
+

;; DEFINE: vnitrni define

(define x 10)
(environment->list (the-environment))
(set! x 20)
(define + *)
(environment->list (the-environment))
(+ 1 1)
(define + (cdr (lookup-env (environment-parent (the-environment)) '+)))
(+ 1 1)

(number? 10)
(number? 'ahoj)
(symbol? 'ahoj)
(procedure? +)
(procedure? (lambda (x) x))
(procedure? 10)
(pair? '())

(primitive? +)
(primitive? define)
(primitive? (lambda (x) x))
(user-procedure? (lambda (x) x))
(specform? define)
(form? define)
(void? (if #f #f))
(eq? 1 1.0)
(eq? '() '())
(eq? 'ahoj 'ahoj)
(eq? '() #t)
(eq? (cons 1 '()) '(1))

(member 'a '(1 2 3 a 4 5 6))
(memq 'a '(1 2 3 a 4 5 6))
(memq 2 '(1 2 3 a 4 5 6))
(memq 2.0 '(1 2.0 3 a 4 5 6))
(memv 2.0 '(1 2.0 3 a 4 5 6))
(assoc 'a '((1 . 10) (2 . 20) (a . (1 2 3)) (b 20)))
(assoc 1 '((1 . 10) (2 . 20) (a . (1 2 3)) (b 20)))
(assoc 2 '((1 . 10) (2 . 20) (a . (1 2 3)) (b 20)))
(assoc 'b '((1 . 10) (2 . 20) (a . (1 2 3)) (b 20)))
(assq 2.0 '((1 . 10) (2.0 . 20) (a . (1 2 3)) (b 20)))
(assv 2.0 '((1 . 10) (2.0 . 20) (a . (1 2 3)) (b 20)))

(macro (lambda (x y) x))
(macro-transformer (macro (lambda (x y) x)))

(define m (macro (lambda (x y) x)))
(m 1 2)
(m 1 nevyhodi-chybu)

(define let
  (macro
    (lambda (bindings . body)
      (append (list (list 'lambda
			  (map car bindings)
			  (cons 'begin body)))
	      (map cadr bindings)))))

(let ((x 10)
      (y 20))
  (+ x y))

(define m
  (macro
    (lambda (expr)
      (let ((s (gensym)))
        `(let ((,s 10))
	   (+ ,s ,expr))))))
